ForceEnableUpgrades(2)
ClearGameEventCallbacks()
artifact_check_radius 	<- 110
artifact_spawn_points 	<- []
artifact_models 		<- ["models/buildables/gibs/sapper_gib002.mdl", "models/buildables/gibs/sd_sapper_gib002.mdl", 	"models/buildables/gibs/sentry1_gib1.mdl", "models/buildables/gibs/sentry2_gib1.mdl",  "models/buildables/gibs/sapper_gib001.mdl", 	"models/buildables/gibs/teleporter_gib2.mdl"]
artifact_size 			<- [1.15, 										1.15, 											1, 											1, 											1.5 										1.2]
artifact_color 			<- ["130 255 113", 								"130 255 113", 									"0 255 100", 								"0 255 100", 								"130 255 113", 								"0 255 100"]
artifact_skin 			<- [0, 											0, 												1, 											1, 											0, 											1]

//artifact spawner
function artifact(){
	spawnfinder()
	local artifact_spawn = artifact_spawn_points[RandomInt(0, artifact_spawn_points.len()-1)]
	local random_prop = RandomInt(0, artifact_models.len()-1)
	local random_model 	= artifact_models[random_prop]
	local random_size 	= artifact_size[random_prop]
	local random_color 	= artifact_color[random_prop]
	local random_skin 	= artifact_skin[random_prop]
    local artifact = SpawnEntityFromTable("prop_physics_override",{
        targetname    = "artifact",
        Model         = random_model,
        solid         = 6,
        origin        = artifact_spawn,
        angles        = "0 0 0",
        thinkfunction = "artifactThink",
        vscripts      = "artifact_system.nut",
		modelscale 	  = random_size,
		rendercolor	  = random_color,
		renderfx 	  = 2,
		renderamt 	  = 210,
		rendermode 	  = 0,
		skin 		  = random_skin,
		spawnflags 	  = 4,
    	}
	)
}

//artifact think script
const RETHINK_TIME = 0.1
function artifactThink(){
    local nearbyplayer = Entities.FindByClassnameNearest("player", self.GetOrigin(), artifact_check_radius)
    local nearbyplayergun = NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 0)
    local nearbyplayerknife = NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 1)

    if (nearbyplayer) { //printl("player nearby")
        if (nearbyplayergun || nearbyplayerknife) { //printl("player has a gun")
		}
        else {
            if (nearbyplayer.GetCurrency() != 4) { //increases players gunpart score
                nearbyplayer.AddCurrency(1)
				ClientPrint(nearbyplayer, 3, nearbyplayer.GetCurrency() + " out of 5 artifacts acquired!")
                self.Destroy()
                artifact()
            }
            else {//gives player gun
				self.Destroy()
				artifact()
				nearbyplayer.Regenerate(true)
				local sheriffgun 	= NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 0)
				local sheriffknife 	= NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 1)
				local sheriffsapper = NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 2)
				local sheriffpda 	= NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 3)
				local sheriffinvis 	= NetProps.GetPropEntityArray(nearbyplayer, "m_hMyWeapons", 4)
                nearbyplayer.SetCurrency(0)
				ClientPrint(nearbyplayer, 3, "Gun acquired!")
				nearbyplayer.Weapon_SetLast(sheriffsapper)
				sheriffgun.AddAttribute("damage bonus", 10, -1)
				sheriffgun.AddAttribute("Reload time decreased", 4.5, -1)
				sheriffgun.AddAttribute("fire rate penalty", 1, -1)
				sheriffgun.AddAttribute("maxammo secondary increased", 10, -1)
				sheriffgun.AddAttribute("mod max primary clip override", 1, -1)
				sheriffgun.AddAttribute("cloak consume rate decreased", 1000, -1)
				sheriffgun.AddAttribute("cannot disguise", 1, -1)
				sheriffgun.SetClip1(0)
				if (sheriffpda		!= null) {sheriffpda.Kill()}
				if (sheriffknife 	!= null) {sheriffknife.Kill()}
				if (sheriffinvis 	!= null) {sheriffinvis.Kill()}
				nearbyplayer.Weapon_Switch(sheriffsapper)
            }
        }
    }
	//kills self if round is not ongoing
	if (GetRoundState() != 4) {
		self.Destroy()
	}
    return RETHINK_TIME
}

function spawnfinder(){
	artifact_spawn_points.clear()
	local spawnpoints = null
	while(spawnpoints = Entities.FindByClassname(spawnpoints, "info_player_teamspawn")){
		
		artifact_spawn_points.append(spawnpoints.GetCenter())
	}
}
__CollectGameEventCallbacks(this)
